--Lens Flare effect filter by khaver

obs = obslua

SETTING_CENTERX = 'centerx'
SETTING_CENTERY = 'centery'
SETTING_AMOUNT = 'amount'
SETTING_COMPLEX = 'complex'
SETTING_ZOOM = 'zoom'
SETTING_SCATTER = 'scatter'
SETTING_AFFECT = 'affect'
SETTING_THRESH = 'thresh'
SETTING_GLINT = 'glint'
SETTING_RAYS = 'rays'
SETTING_ANIMATE = 'animate'
SETTING_BLADES = 'blades'
SETTING_SHUTTER = 'shutter'
SETTING_POINTS = 'points'

TEXT_CENTERX = 'Center X'
TEXT_CENTERY = 'Center Y'
TEXT_AMOUNT = 'Amount'
TEXT_COMPLEX = 'Complexity'
TEXT_ZOOM = 'Flare Zoom'
TEXT_SCATTER = 'Light Scatter'
TEXT_AFFECT = 'Use Image Intensity'
TEXT_THRESH = 'Threshold'
TEXT_GLINT = 'Brightness'
TEXT_RAYS = 'Ray Count'
TEXT_ANIMATE = 'Animate Rays'
TEXT_BLADES = 'Shutter Blades'
TEXT_SHUTTER = 'Shutter Offset'
TEXT_POINTS = 'Points Offset'

-- Returns the description displayed in the Scripts window
function script_description()
  return [[Lens Flare effect filter by khaver]]
end

function script_load(settings)
  obs.obs_register_source(source_info)
end

source_info = {}
source_info.id = 'filter-lensflare'
source_info.type = obs.OBS_SOURCE_TYPE_FILTER
source_info.output_flags = obs.OBS_SOURCE_VIDEO

source_info.get_name = function()
    return "Lens Flare"
end

source_info.create = function(settings, source)

    local filter = {}
    filter.source = source
	filter.width = 1
	filter.height = 1

    obs.obs_enter_graphics()
    --local effect_path = script_path() .. 'filter-lensflare/filter-lensflare.effect'
    --filter.effect = obs.gs_effect_create_from_file(effect_path, nil)
    filter.effect = obs.gs_effect_create(shader, nil, nil)
    obs.obs_leave_graphics()

    if filter.effect == nil then
        source_info.destroy(filter)
        return nil
    end

    filter.params = {}
        filter.params.centerx = obs.gs_effect_get_param_by_name(filter.effect, 'centerx')
        filter.params.centery = obs.gs_effect_get_param_by_name(filter.effect, 'centery')
        filter.params.amount = obs.gs_effect_get_param_by_name(filter.effect, 'amount')
        filter.params.complex = obs.gs_effect_get_param_by_name(filter.effect, 'complex')
        filter.params.zoom = obs.gs_effect_get_param_by_name(filter.effect, 'zoom')
        filter.params.scatter = obs.gs_effect_get_param_by_name(filter.effect, 'scatter')
        filter.params.affect = obs.gs_effect_get_param_by_name(filter.effect, 'affect')
        filter.params.thresh = obs.gs_effect_get_param_by_name(filter.effect, 'thresh')
        filter.params.glint = obs.gs_effect_get_param_by_name(filter.effect, 'glint')
        filter.params.rays = obs.gs_effect_get_param_by_name(filter.effect, 'rays')
        filter.params.animate = obs.gs_effect_get_param_by_name(filter.effect, 'animate')
        filter.params.blades = obs.gs_effect_get_param_by_name(filter.effect, 'blades')
        filter.params.shutter = obs.gs_effect_get_param_by_name(filter.effect, 'shutter')
        filter.params.points = obs.gs_effect_get_param_by_name(filter.effect, 'points')
        filter.params.width = obs.gs_effect_get_param_by_name(filter.effect, 'width')
        filter.params.height = obs.gs_effect_get_param_by_name(filter.effect, 'height')
		filter.params.time = obs.gs_effect_get_param_by_name(filter.effect, 'time')

    source_info.update(filter, settings)
    return filter
end

source_info.destroy = function(filter)
    if filter.effect ~= nil then
        obs.obs_enter_graphics()
        obs.gs_effect_destroy(filter.effect)
		filter.effect = nil
        obs.obs_leave_graphics()
    end
end

source_info.get_width = function(filter)
    return filter.width
end

source_info.get_height = function(filter)
    return filter.height
end

source_info.get_properties = function(settings)
    props = obs.obs_properties_create()

    obs.obs_properties_add_float_slider(props, SETTING_CENTERX, TEXT_CENTERX, -1.0, 1.0, 0.0001)
    obs.obs_properties_add_float_slider(props, SETTING_CENTERY, TEXT_CENTERY, -1.0, 1.0, 0.0001)
    obs.obs_properties_add_float_slider(props, SETTING_AMOUNT, TEXT_AMOUNT, 0.0, 1.0, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_COMPLEX, TEXT_COMPLEX, 0.0, 10.0, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_ZOOM, TEXT_ZOOM, 0.0, 1.0, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_SCATTER, TEXT_SCATTER, 0.0, 1.0, 0.001)
    obs.obs_properties_add_bool(props, SETTING_AFFECT, TEXT_AFFECT)
    obs.obs_properties_add_float_slider(props, SETTING_THRESH, TEXT_THRESH, 0.0, 1.0, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_GLINT, TEXT_GLINT, 0.0, 1.0, 0.001)
    obs.obs_properties_add_float_slider(props, SETTING_RAYS, TEXT_RAYS, 0.0, 50.0, 0.1)
    obs.obs_properties_add_bool(props, SETTING_ANIMATE, TEXT_ANIMATE)
    obs.obs_properties_add_int(props, SETTING_BLADES, TEXT_BLADES, 5, 8, 1)
    obs.obs_properties_add_float_slider(props, SETTING_SHUTTER, TEXT_SHUTTER, 0.0, 1.0, 0.0001)
    obs.obs_properties_add_float_slider(props, SETTING_POINTS, TEXT_POINTS, 0.0, 1.0, 0.0001)

    return props
end

source_info.get_defaults = function(settings)
    obs.obs_data_set_default_double(settings, SETTING_CENTERX, -0.375)
    obs.obs_data_set_default_double(settings, SETTING_CENTERY, 0.25)
    obs.obs_data_set_default_double(settings, SETTING_AMOUNT, 1.0)
    obs.obs_data_set_default_double(settings, SETTING_COMPLEX, 10.0)
    obs.obs_data_set_default_double(settings, SETTING_ZOOM, 0.0)
    obs.obs_data_set_default_double(settings, SETTING_SCATTER, 0.0)
    obs.obs_data_set_default_bool(settings, SETTING_AFFECT, false)
    obs.obs_data_set_default_double(settings, SETTING_THRESH, 0.0)
    obs.obs_data_set_default_double(settings, SETTING_GLINT, 1.0)
    obs.obs_data_set_default_double(settings, SETTING_RAYS, 12.0)
    obs.obs_data_set_default_bool(settings, SETTING_ANIMATE, true)
    obs.obs_data_set_default_int(settings, SETTING_BLADES, 6)
    obs.obs_data_set_default_double(settings, SETTING_SHUTTER, 0.9)
    obs.obs_data_set_default_double(settings, SETTING_POINTS, 0.9)
end

source_info.update = function(filter, settings)
    filter.centerx = obs.obs_data_get_double(settings, SETTING_CENTERX)
    filter.centery = obs.obs_data_get_double(settings, SETTING_CENTERY)
    filter.amount = obs.obs_data_get_double(settings, SETTING_AMOUNT)
    filter.complex = obs.obs_data_get_double(settings, SETTING_COMPLEX)
    filter.zoom = obs.obs_data_get_double(settings, SETTING_ZOOM)
    filter.scatter = obs.obs_data_get_double(settings, SETTING_SCATTER)
    filter.affect = obs.obs_data_get_bool(settings, SETTING_AFFECT)
    filter.thresh = obs.obs_data_get_double(settings, SETTING_THRESH)
    filter.glint = obs.obs_data_get_double(settings, SETTING_GLINT)
    filter.rays = obs.obs_data_get_double(settings, SETTING_RAYS)
    filter.animate = obs.obs_data_get_bool(settings, SETTING_ANIMATE)
    filter.blades = obs.obs_data_get_int(settings, SETTING_BLADES)
    filter.shutter = obs.obs_data_get_double(settings, SETTING_SHUTTER)
    filter.points = obs.obs_data_get_double(settings, SETTING_POINTS)

end

source_info.video_render = function(filter)

  local parent = obs.obs_filter_get_parent(filter.source)
  filter.width = obs.obs_source_get_base_width(parent)
  filter.height = obs.obs_source_get_base_height(parent)
  filter.time = os.clock()

    obs.obs_source_process_filter_begin(filter.source, obs.GS_RGBA, obs.OBS_NO_DIRECT_RENDERING)

    obs.gs_effect_set_float(filter.params.centerx, filter.centerx)
    obs.gs_effect_set_float(filter.params.centery, filter.centery)
    obs.gs_effect_set_float(filter.params.amount, filter.amount)
    obs.gs_effect_set_float(filter.params.complex, filter.complex)
    obs.gs_effect_set_float(filter.params.zoom, filter.zoom)
    obs.gs_effect_set_float(filter.params.scatter, filter.scatter)
    obs.gs_effect_set_bool(filter.params.affect, filter.affect)
    obs.gs_effect_set_float(filter.params.thresh, filter.thresh)
    obs.gs_effect_set_float(filter.params.glint, filter.glint)
    obs.gs_effect_set_float(filter.params.rays, filter.rays)
    obs.gs_effect_set_bool(filter.params.animate, filter.animate)
	obs.gs_effect_set_int(filter.params.blades, filter.blades)
    obs.gs_effect_set_float(filter.params.shutter, filter.shutter)
    obs.gs_effect_set_float(filter.params.points, filter.points)
	obs.gs_effect_set_int(filter.params.width, filter.width)
	obs.gs_effect_set_int(filter.params.height, filter.height)
    obs.gs_effect_set_float(filter.params.time, filter.time)

    obs.obs_source_process_filter_end(filter.source, filter.effect, filter.width, filter.height)
end

shader = [[
//Lens Flare effect filter by khaver


uniform float4x4 ViewProj;
uniform texture2d image;

uniform float centerx;
uniform float centery;
uniform float amount;
uniform float complex;
uniform float zoom;
uniform float scatter;
uniform bool affect;
uniform float thresh;
uniform float glint;
uniform float rays;
uniform bool animate;
uniform int blades;
uniform float shutter;
uniform float points;
uniform int width;
uniform int height;
uniform float time;

sampler_state textureSampler {
    Filter    = Linear;
    AddressU  = Clamp;
    AddressV  = Clamp;
};

struct VertDataIn {
    float4 pos : POSITION;
    float2 uv  : TEXCOORD0;
};

struct VertDataOut {
    float4 pos : POSITION;
    float2 uv  : TEXCOORD0;
};

VertDataOut VSDefault(VertDataIn v_in)
{
    VertDataOut vert_out;
    vert_out.pos = mul(float4(v_in.pos.xyz, 1.0), ViewProj);
    vert_out.uv  = v_in.uv;
    return vert_out;
}

float rnd(float w)
{
	return frac(sin(w) * 1000.0);
}

float noise1(float t)
{
	return (animate) ? image.Sample(textureSampler, float2 (t * 10.0 / width, 0.0)).x : 1.0;
}

float noise2(float2 t)
{
	 return animate ? image.Sample(textureSampler, ((t * 10.0 / width) + (time * 0.05).xx)).x : 1.0;
}

float vary ()
{
   float pixX = 1.0 / float(width);
   float pixY = 1.0 / float(height);

   float2 iMouse = float2(centerx + 0.5, 1.0 - (centery + 0.5));

   float4 col = image.Sample(textureSampler, iMouse);
   col += image.Sample(textureSampler, iMouse - float2 (pixX, pixY));
   col += image.Sample(textureSampler, float2 (iMouse.x, iMouse.y - pixY));
   col += image.Sample(textureSampler, iMouse + float2 (pixX, -pixY));

   col += image.Sample(textureSampler, float2 (iMouse.x - pixX, iMouse.y));
   col += image.Sample(textureSampler, float2 (iMouse.x + pixX, iMouse.y));

   col += image.Sample(textureSampler, iMouse - float2 (pixX, -pixY));
   col += image.Sample(textureSampler, float2 (iMouse.x, iMouse.y + pixY));
   col += image.Sample(textureSampler, iMouse + float2 (pixX, pixY));

   col /= 9.0;

   return dot (col.rgb, float3 (0.33333, 0.33334, 0.33333));
}

float regShape (float2 p, int N)
{
   float a = atan2(p.x, p.y) + 0.2;
   float b = 6.28319 / float(N);

   return smoothstep(0.5, 0.51, cos(floor(0.5 + a / b) * b - a) * length(p.xy));
}

float3 circle (float2 p, float size, float decay, float3 color, float3 color2, float dist, float2 mouse, float i)
{
   float complexity = ceil(complex);
   float po = points / 10.0;

   int bladecnt = blades; // + 5;

   p *= 1.0 - zoom;

   float l = length(p + mouse * (dist * 4.0)) + size / 2.0;

   float l2 = length(p + mouse * (dist * 4.0)) + size / 3.0;

   float c  = max(0.01-pow (length (p + mouse * dist), size * 1.4), 0.0) * 50.0;
   float c1 = max(0.001 - pow(l - 0.3, 1.0 / 40.0) + sin(l * 30.0), 0.0) * 3.0;
   float c2 = max(0.04 / pow(length(p - mouse * dist / 2.0 + po), 1.0), 0.0) / 20.0;
   float s  = max(0.01 - pow(regShape(p * 5.0 + mouse * dist * 5.0 + shutter, float(bladecnt)), 1.0), 0.0) * 5.0;

   color = cos(float3(0.44, 0.24, 0.2) * 8.0 + dist * 4.0) * 0.5 + 0.5;

   return (i > complexity) ? 0.0.xxx : ((c + c1 + c2 + s) * color) - 0.01.xxx;
}

float4 PassThrough(VertDataOut v_in) : TARGET
{

   float raycnt = ceil(rays);
   float v = vary ();
   float2 fragCoord = v_in.uv;
   float _OutputAspectRatio = float(width) / float(height);
   float CTIME = time;
   if (!animate) CTIME = 3.456;

   if (v < thresh) v = 0.0;
   if (!affect) v = 1.0;

   float affected = saturate(glint - (1.0 - v));

   float3 orig = image.Sample(textureSampler, fragCoord).rgb;

   float2 uv = fragCoord - 0.5.xx;
   float2 mm = float2 ((centerx) * _OutputAspectRatio, centery * -1.0);  //float2 ((centerx - 0.5) * _OutputAspectRatio, 0.5 - centery);

   uv.x *= _OutputAspectRatio;

   float3 circColor = float3(0.9, 0.2, 0.1);
   float3 circColor2 = float3(0.3, 0.1, 0.5);

   //now to make the sky not black

    float3 color = (0.0 - 0.52 * sin(CTIME / 0.4) * 0.1 + 0.2).xxx * scatter;

   for (int i = 0; i < 10; i++) {
      color += circle (uv, pow(rnd(i * 2000.0), 2.0) + 1.41, 0.0, circColor + float(i).xxx, circColor2 + float(i).xxx, rnd(i * 20.0) * 3.0 - 0.3, mm, float(i));
   }

   //get angle and length of the sun (uv - mouse)

   float a = atan2(uv.y - mm.y, uv.x - mm.x);
   float l = pow(length(uv - mm), 0.1);
   float n = noise2(float2((a - CTIME / 9.0) * 16.0, l * 32.0));

   float bright = 0.1;

   color += (1.0 / (length(uv - mm) * 16.0 + 1.0) * affected).xxx;
   color += (color * (sin((a + CTIME / 18.0 + noise1(abs(a) +n / 2.0) * 2.0) * raycnt) * 0.1 + l * 0.1 + 0.8)) * affected;

   color += ((max(bright / pow(length(uv - mm) * 4.0, 0.5), 0.0) * 4.0) * float3(0.2, 0.21, 0.3) * 4.0) * affected;

   color *= exp(1.0 - length(uv - mm)) / 5.0;

   return float4(saturate(orig + (color * v * amount)), 1.0);
}

technique Draw
{
    pass
    {
        vertex_shader = VSDefault(v_in);
        pixel_shader  = PassThrough(v_in);
    }
}
]]